#!/usr/bin/perl -w
# dansguardian-lib.pl

do '../web-lib.pl';
&init_config();
%access = &get_module_acl();
$pidfilepath = "$config{'pid_file'}";

# Get the DG version
if (open(VERSION, "$module_config_directory/version")) {
  chop($dg_version = <VERSION>);
  close(VERSION);
}
# Get the AVPlugin version, if any
if (open(AVPLUGINVERSION, "$module_config_directory/avpluginversion")) {
  chop($avplugin_version = <AVPLUGINVERSION>);
  close(AVPLUGINVERSION);
}

# Read in the dansguardian.conf file
$cfref = read_file_lines($conffilepath);
$avcfref = read_file_lines($avconffilepath);
$modulever = "0.5.5";

sub readconfigoption {
    my $option = $_[0];
    my $value;
    my $name;
    my $line;
    foreach $line (@$cfref) {
        ($name, $value) = split(/=/, $line);
        $name =~ s/ //g;
        if ($name eq $option) {
            $value =~ s/ //g;
            $value =~ s/^'//g;
            $value =~ s/'.*$//g;
            return $value;
        }
    }
}

sub readavconfigoption {
    my $option = $_[0];
    my %configmappings = ("avpluginquarantinedir" => "Quarantine Dir","avplugindownloaddir" => "Download Dir","avpluginlogfacility" => "Log Facility","avpluginvirusscanner" => "Virus Scanner","avpluginsweep" => "Sweep","avpluginvirusscannertimeout" => "Virus Scanner Timeout","avpluginlocalpostmaster" => "Local Postmaster","avpluginmaildomain" => "Mail Domain", "avpluginmailserver" => "Mail Server", "avpluginmailtype" => "Mail Type","avpluginaction" => "Action","avplugindebug" => "Debug","avpluginlockfiledir" => "Lock File Dir","avpluginminimumcodestatus" => "Minimum Code Status");
    my $value;
    my $name;
    my $line;
    foreach $line (@$avcfref) {
        ($name, $value) = split(/=/, $line);
        $name =~ s/^\s*//g;
	$name =~ s/\s*$//g;
        if ($name =~ /^$configmappings{$option}$/i) {
            $value =~ s/^\s*//g;
	    $value =~ s/\#.*$//g;
	    $value =~ s/\s*$//g;
            return $value;
        }
    }
}

# form_line(<configfileoptionname>, <icon size>, <icon max len>, <editable file>)
sub form_line {
    my $option = $_[0];
    my $size = $_[1];
    my $maxlen = $_[2];
    my $helpfile = $_[3];
    my $editable = $_[4];
    my $optionconf = "conf_$option";
    my $label = $text{$optionconf};
    my $value = readconfigoption($option);
    print "<tr>", "<td>", &hlink("$label", "$helpfile"), "</td>", "<td><input name=$option size=$size maxlength=$maxlen value=$value>";
    if ($editable ne "") {
        print " <A HREF=\"./edit.cgi?file=$value\">$editable</a>";
    }
    print "</td></tr>\n";
}

# av_form_line(<configfileoptionname>, <icon size>, <icon max len>, <editable file>)
sub av_form_line {
    my $option = $_[0];
    my $size = $_[1];
    my $maxlen = $_[2];
    my $helpfile = $_[3];
    my $editable = $_[4];
    my $optionconf = "conf_$option";
    my $label = $text{$optionconf};
    my $value = readavconfigoption($option);
    print "<tr>", "<td>", &hlink("$label", "$helpfile"), "</td>", "<td><input name=$option size=$size maxlength=$maxlen value=$value>";
    if ($editable ne "") {
        print " <A HREF=\"./edit.cgi?file=$value\">$editable</a>";
    }
    print "</td></tr>\n";
}

# edit_line_file(<configfileoptionname>, <icon size>, <icon max len>, <editable file>)
sub edit_line_file {
    my $option = $_[0];
    my $helpfile = $_[1];
    my $optionconf = "conf_$option";
    my $label = $text{$optionconf};
    my $value = readconfigoption($option);
    print "<tr>", "<td>", &hlink("$label", "$helpfile"), "</td>", "<td>$value</td>", "<td><A HREF=\"./edit.cgi?file=$value\">$text{'index_edit'}</a></td></tr>\n";
    # search the file for '.Include<...>' directives and list any files found
    $fileref = read_file_lines($value);
    my $file_line;
    my $file_count = 0;
    my $output_string = "";

    foreach $file_line (@{$fileref}) {
        if ($file_line =~ /^\s*\.Include\<([^\>]+)\>.*$/) {
	    if ($file_count != 0) {
	        $output_string .= "<tr>";
	    }
            $output_string .= "<td>$1</td><td><A HREF=\"./edit.cgi?file=$1\">$text{'index_edit'}</A></td></tr>\n";
	    $file_count++;
	}
    }
    if ($output_string ne "") {
        print "<tr><td rowspan=\"$file_count\">&nbsp;</td>$output_string</tr>\n";
    }
}

# form_option(<configfileoptionname>)
sub form_option {
    my $option = $_[0];
    my $helpfile = $_[1];
    my $optionconf = "conf_$option";
    my $label = $text{$optionconf};
    my $value = readconfigoption($option);
    print "<tr><td>", &hlink("$label", "$helpfile"), "</td>", "<td><input type=checkbox name=$option value=\"on\"";
    if ($value eq 'on') {
        print 'CHECKED';
    }
    print "></td></tr>\n";
}

# form_radio(<configfileoptionname>, <option 1>, <option 2>, ...)
sub form_radio {
    my @options = @_;
    my $option = $options[0];
    my $optionconf = "conf_$option";
    my $optionradio = $optionconf . "_radio_";
    my $label = $text{$optionconf};
    my $helpfile = $options[0];
    my $value = readconfigoption($option);
    my $radio = "blah";
    my $radioname;
    my $i = 1;
    print "<tr><td>", &hlink("$label", "$helpfile"), "</td><td>";
    while($radio ne "") {
        $radio = $options[$i];
        if (length($radio) > 0) {
            print "<INPUT TYPE=RADIO NAME=\"$option\" VALUE=\"$radio\"";
            if ($radio eq $value) {
                print " CHECKED";
            }
            $radioname = $optionradio . "$i";
            print "> $radio = $text{$radioname}<BR>";
        }
        $i++;
    }
    print "</td></tr>\n";
}

# av_form_radio(<configfileoptionname>, <option 1>, <option 2>, ...)
sub av_form_radio {
    my @options = @_;
    my $option = $options[0];
    my $optionconf = "conf_$option";
    my $optionradio = $optionconf . "_radio_";
    my $label = $text{$optionconf};
    my $helpfile = $options[0];
    my $value = readavconfigoption($option);
    my $radio = "blah";
    my $radioname;
    my $i = 1;
    print "<tr><td>", &hlink("$label", "$helpfile"), "</td><td>";
    while($radio ne "") {
        $radio = $options[$i];
        if (length($radio) > 0) {
            print "<INPUT TYPE=RADIO NAME=\"$option\" VALUE=\"$radio\"";
            if ($radio eq $value) {
                print " CHECKED";
            }
            $radioname = $optionradio . "$i";
            print "> $radio = $text{$radioname}<BR>";
        }
        $i++;
    }
    print "</td></tr>\n";
}

sub form_file {
    my $option = $_[0];
    my $fileref = read_file_lines($option);
    my $line;
    print "<INPUT TYPE=HIDDEN NAME=\"filename\" VALUE=\"$option\">";
    print "<TEXTAREA NAME=\"filecontents\" ROWS=30 COLS=80>";
    foreach $line (@$fileref) {
        print "$line\n";
    }
    print "</TEXTAREA>";
}

# restart_button()
# Returns HTML for a link to put in the top-right corner
# I stole this from the apache module
sub restart_button {
  my $pidfile = "$pidfilepath";
  if ($access{'start'}) {
    if (open(PID, $pidfile) && <PID> =~ /(\d+)/ && kill(0, $1)) {
        close(PID);
        $rv = "<a href=\"restart.cgi\">$text{'header_restartdg'}</a><br>\n";
        $rv .= "<a href=\"stop.cgi\">$text{'header_stopdg'}</a>\n";
    }
    else {
        $rv = "<a href=\"start.cgi\">$text{'header_startdg'}</a><br>\n";
    }
    return $rv;
  }
}
