#!/usr/bin/perl
# editconf.cgi

require './dansguardian-lib.pl';
use POSIX;
&ReadParse();
&header($text{'edit_dgconfig'}, "");
%access = &get_module_acl();

if (!$access{'editconf'}) {
  print "<p>$text{'index_notauth'}\n";
  &footer("index.cgi", $text{'index_return'});
  exit;
}

# Check if DansGuardian conf file is there
$conffilepath = "$config{'conf_file'}";
if (!(-f $conffilepath)) {
    print "<p>";
    print &text('error_confnotfound', $conffilepath, "/config.cgi?$module_name"),"<p>\n";
    print "$text{'index_confloc'} $conffilepath.";
    print "<hr>\n";
    &footer("index.cgi", $text{'index_return'});
    exit;
}
print "$text{'index_dgversion'} $dg_version<br>\n";
if ($avplugin_version ne "") {
  print "$text{'index_avpluginversion'} $avplugin_version<br>\n";
}
print "<p align=left>$text{'index_clickhelp'}</p>";

print "<form action=saveconf.cgi method=post>\n";
$cfref = read_file_lines($conffilepath);
print "<INPUT TYPE=HIDDEN NAME=\"conffilepath\" VALUE=\"$conffilepath\">";
print "<table border=1 width=100% cellspacing=1 cellpadding=1>\n";
if (! $dg_version lt "2.7.0") {
	&form_line("htmltemplate", 64, 256, "htmltemplate");
	print '<P>';
}
&form_line("filterip", 15, 15, "filterip");
print '<P>';
&form_line("filterport", 4, 5, "filterport");
print '<P>';
&form_line("proxyip", 15, 15, "proxyip");
print '<P>';
&form_line("proxyport", 4, 5, "proxyport");
print '<P>';
&form_line("accessdeniedaddress", 56, 128, "accessdeniedaddress");
print '<P>';

my @filepaths = ( 'bannedphraselist', 'banneduserlist', 'bannediplist', 'bannedextensionlist', 'bannedmimetypelist', 'bannedsitelist', 'bannedurllist', 'bannedregexpurllist', 'exceptionphraselist', 'exceptionsitelist', 'exceptionuserlist', 'exceptioniplist', 'exceptionurllist', 'weightedphraselist', 'picsfile' );
if ($dg_version ge "2.5.3") {
  push(@filepaths, 'contentregexplist', 'languagefile');
}

foreach (@filepaths) {
  &form_line("$_", 64, 256, "filepaths");
  print '<P>';
}

&form_line("maxuploadsize", 4, 6, "post");
print '<P>';
&form_line("maxchildren", 3, 4, "maxchildren");
print '<P>';

if ($dg_version ge "2.4.3") {
  &form_radio("weightedphrasemode","0","1","2");
  print "<p>";
}

&form_line("naughtynesslimit", 3, 3, "naughtyness");
print '<P>';

if ($dg_version ge "2.4.2") {
  &form_radio("loglevel","0","1","2","3");
  print "<p>";
}

&form_option("logexceptionhits", "logexception");
print '<P>';
&form_option("showweightedfound", "showweighted");
print '<P>';

if ($dg_version ge "2.5.3") {
  &form_line("urlcachenumber", 4, 4, "urlcachenumber");
  print "<p>";
  &form_line("urlcacheage", 4, 4, "urlcacheage");
  print "<p>";
  &form_line("maxcontentfiltersize", 6, 6, "maxcontentfiltersize");
  print "<p>";
}

if ($dg_version ge "2.7.0") {
  &form_line("languagedir", 64, 256, "languagedir");
  print "<p>";
  &form_line("language", 25, 50, "language");
  print "<p>";
  &form_radio("phrasefiltermode","0","1","2");
  print "<p>";
  &form_option("preservecase", "preservecase");
  print "<p>";
  &form_option("hexdecodecontent", "hexdecodecontent");
  print "<p>";
  &form_option("forcequicksearch", "forcequicksearch");
  print "<p>";
  &form_line("minchildren", 3, 3, "minchildren");
  print "<p>";
  &form_line("minsparechildren", 3, 3, "minsparechildren");
  print "<p>";
  &form_line("preforkchildren", 3, 3, "preforkchildren");
  print "<p>";
  &form_line("maxsparechildren", 3, 3, "maxsparechildren");
  print "<p>";
  &form_line("maxagechildren", 6, 6, "maxagechildren");
  print "<p>";
}

&form_option("reverseaddresslookups", "reverselookup");
print "<p>";
&form_option("createlistcachefiles", "createlistcache");
print "<p>";

&form_option("usernameidmethodproxyauth", "usernameauth");
print "<p>";
&form_option("usernameidmethodident", "usernameauth");
print "<p>";
&form_option("forwardedfor", "forwardedfor");
print "<p>";

if ($dg_version ge "2.4.6") {
  &form_option("usexforwardedfor", "usexforwardedfor");
  print "<p>";
}

&form_option("logconnectionhandlingerrors", "logconnecterr");
print "<p>";

if ($dg_version ge "2.5.3") {
  &form_radio("logfileformat","1","2","3","4");
} else {
  &form_radio("logfileformat","1","2");
}

print "<p>";
&form_radio("reportinglevel","-1","0","1","2","3");

if (($dg_version ge "2.4.5-2") && ($avplugin_version ge "1.0")) {
  &form_option("virusscan", "virusscan");
  print "<p>";
  if ($avplugin_version ge "1.0" and $avplugin_version !~ /1.0rc/)
  {
    &form_line("exceptionvirusmimetypelist", 64, 256, "exceptionvirusmimetype");
    print "<p>";
    &form_line("exceptionvirusextensionlist", 64, 256, "exceptionvirusextension");
  }
}

print "</table>";
print "<p>";
print "<P><input type=submit value=\"$text{'save'}\"></form>\n";
print "<hr>\n";
&footer("index.cgi", $text{'index_return'}, "editconf.cgi", $text{'edit_dgconfig'}, "editfiles.cgi", $text{'edit_dgfiles'});
exit;
