#!/usr/bin/perl
# index.cgi

require './dansguardian-lib.pl';
use POSIX;
&ReadParse();
%access = &get_module_acl();

# Check the version number
$ver = `$config{'binary_file'} -v 2>&1`;
$avpluginver = `$config{'binary_file'} -P 2>&1`;

## Verify that the binary and conf files exist and binary is executable
if (-x $config{'binary_file'} && -f $config{'conf_file'}) {
  ## If it is, check the version
  if ($ver =~ /(2\.4\.\d+-?(\d+)?)/ || $ver =~ /(2\.5\.\d+-?(\d+)?)/ || $ver =~ /(2\.6\.\d+-?(\d+)?)/ || $ver =~ /(2\.7\.\d+-?(\d+)?)/) {
      # Save version number
      open(VERSION, ">$module_config_directory/version");
      print VERSION $1,"\n";
      close(VERSION);
      $dg_version = $1;
      }
  ## Version is not supported
    else {
     &header($text{'index_header'}, "", undef, 1, 1);
      print "<hr>\n";
      print "<p>";
      print "$text{'index_dgver'} $config{'binary_file'}<br>\n";
      print "<pre>$dg_version</pre>\n";
      print "<hr>\n";
      &footer("/", $text{'index_return'});
      exit;
  }
## Binary or conf file does not exist or is not executable, warn the user
} else {
  &header($text{'index_header'}, "", undef, 1, 1);
  print "<hr>\n";
  print "<p>";
  print "$text{'error_modconfig'}<br>\n";
  print "$text{'index_binaryloc'} $config{'binary_file'}\n";
  print "<br>$text{'index_confloc'} $config{'conf_file'}\n";
  print "<hr>\n";
}

## Now check the AV Plugin version
if ($avpluginver =~ /^AntiVirus\sPlugin\s(\d+\.\d+-?(\w+)?)$/) {
    # Save version number
    open(AVPLUGINVERSION, ">$module_config_directory/avpluginversion");
    print AVPLUGINVERSION $1,"\n";
    close(AVPLUGINVERSION);
    $avplugin_version = $1;
  } else {
    unlink("$module_config_directory/avpluginversion");
}

## Print the Header
&header($text{'index_title'}, "", "intro", 1, 1, 0, &restart_button()."<br>".
  &help_search_link("dansguardian", "man"), undef, undef, &text('index_version')." ".$dg_version);
  
print "$text{'index_modulever'} $modulever\n";

print "<hr>\n";

# Set the arrays for the links, titles, and icons of each option
# NOTE: The .cgi file names MUST be the same as the title and icon for the 
# button! Or if you put the word edit infront of the filename, i.e. editconf.cgi
# then all will be ok as the edit is stripped later.
# Otherwise problems will occur.
#
@olinks = ( "status.cgi", "logs.cgi", "editconf.cgi", "editfiles.cgi" );
if ($avplugin_version ge "1.0") {
    push @olinks, "editavconf.cgi";
}
@otitles = map { $t=$_; $t=~s/.cgi//; "$t" } @olinks;
for($i=0; $i<@otitles; $i++) {
  if (!$access{$otitles[$i]}) {
    splice(@otitles, $i, 1);
    splice(@olinks, $i, 1);
    $i--;
  }
  else {
    $otitles[$i] = $text{'index_'.$otitles[$i]};
  }
}
@oicons =  map { $t=$_; $t=~s/cgi/gif/; $t=~s/edit//; "images/$t" } @olinks;
&icons_table(\@olinks, \@otitles, \@oicons);

print "<hr>\n";
&footer("/", $text{'index'});
exit;
