#!/usr/bin/perl
# saveconf.cgi

#$| = 1;

require './dansguardian-lib.pl';
use POSIX;
&ReadParse();

#&init_config();
#&clean_environment();

&header($text{'saveconf_title'}, "", "saveconf");

# Check if DansGuardian conf file is there
my $conffilepath = "$config{'conf_file'}";
if (!(-f $conffilepath)) {
    print "<p>";
    print &text('error_confnotfound', $conffilepath, "/config.cgi?$module_name"),"<p>\n";
    print "$text{'index_confloc'} $conffilepath.";
    print "<hr>\n";
    &footer("/", $text{'index_return'});
    exit;
}
# Read in the dansguardian.conf file
$cfref = read_file_lines($conffilepath);
my $filename = $in{"conffilepath"};
print "$text{'saveconf_configfile'} <b>$filename</b><p>\n";
print "<b>NOTE:</b> Don't forget to restart DG<p>\n";

# This sets the default config options for ALL DG versions
# Version specific ones are push-ed into the array
#
@configoptions = ("htmltemplate","filterip","filterport","proxyport","proxyip","accessdeniedaddress","bannedphraselist","banneduserlist","bannediplist","bannedextensionlist","bannedmimetypelist","bannedsitelist","bannedurllist","bannedregexpurllist","exceptionphraselist","exceptionsitelist","exceptionuserlist","exceptioniplist","exceptionurllist","weightedphraselist","picsfile","maxuploadsize","maxchildren","naughtynesslimit","logexceptionhits","showweightedfound","reverseaddresslookups","createlistcachefiles","usernameidmethodproxyauth","usernameidmethodident","forwardedfor","logconnectionhandlingerrors","logfileformat","reportinglevel");

if ($dg_version ge "2.4.2") {
  push(@configoptions, "weightedphrasemode", "loglevel");
}

if (($dg_version ge "2.4.5-2") && ($avplugin_version ge "1.0")) {
  push(@configoptions, "virusscan");
  if ($avplugin_version ge "1.0" && $avplugin_version !~ /1.0rc/) {
    push (@configoptions, "exceptionvirusmimetypelist", "exceptionvirusextensionlist");
  }
}

if ($dg_version ge "2.4.6") {
  push(@configoptions, "usexforwardedfor");
}

if ($dg_version ge "2.5.3") {
  push(@configoptions, "contentregexplist", "languagefile", "urlcachenumber", "urlcacheage", "maxcontentfiltersize");
}

if ($dg_version ge "2.7.0") {
  push(@configoptions, "languagedir", "language", "phrasefiltermode", "preservecase", "hexdecodecontent", "forcequicksearch", "minchildren", "minsparechildren", "preforkchildren", "maxsparechildren", "maxagechildren");
}

my $opt;
my $grep_count;
foreach $opt (@configoptions) {
    $grep_count = grep { s/^(\s*$opt\s*=\s*)([^#]*)(.*)$/$1$in{$opt}$3/ } @{$cfref};
    if ($grep_count eq "0") {
        push @{$cfref}, "$opt = $in{$opt}";
    }
}
# write out the modified version of the dansguardian.conf file
&flush_file_lines();

print "<b>$text{'saveconf_configdata'}</b><br>";
print "<pre>\n";
my $conf_line;
foreach $conf_line (@{$cfref}) {
  print "$conf_line\n";
}
print "</pre>\n";

print "<hr>\n";
&footer("index.cgi", $text{'index_return'}, "editconf.cgi", $text{'edit_dgconfig'}, "editfiles.cgi", $text{'edit_dgfiles'});
